"use strict";
var __makeTemplateObject = (this && this.__makeTemplateObject) || function (cooked, raw) {
    if (Object.defineProperty) { Object.defineProperty(cooked, "raw", { value: raw }); } else { cooked.raw = raw; }
    return cooked;
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var chalk_1 = __importDefault(require("chalk"));
var path_1 = require("path");
var rxline_1 = require("rxline");
var fs_1 = require("rxline/fs");
var sdh_1 = require("@connectv/sdh");
var files_1 = require("./files");
var setup_jss_1 = require("../transport/setup-jss");
var bundle_1 = require("./bundle");
var content_1 = require("./content");
var styles_1 = require("./styles");
var toc_1 = require("./toc");
var namespace_1 = require("./namespace");
var post_1 = require("../components/page/meta-override/post");
function build(config, builder, themeInstaller, webpackConfig) {
    return __awaiter(this, void 0, void 0, function () {
        var _bundle, _styles, _toc, source;
        var _this = this;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    setup_jss_1.initJss();
                    _bundle = bundle_1.bundle(config, themeInstaller);
                    _styles = styles_1.styles(config);
                    return [4 /*yield*/, toc_1.loadToC(config)];
                case 1:
                    _toc = _a.sent();
                    source = files_1.files(config);
                    return [2 /*return*/, new Promise(function (resolve, reject) {
                            source
                                .peek(function (file) { return console.log("" + chalk_1.default.gray('# building ........ ' + path_1.join(file.root, file.path))); })
                                .pipe(fs_1.readFile(), content_1.content(builder, _toc, config, _styles), sdh_1.post(_bundle.collect()), sdh_1.post(namespace_1.namespace(config)), sdh_1.post(post_1.pageSpecificMeta), function (file) {
                                (config.page.post || []).forEach(function (p) { return file.content.post(function (html) { return p(html, file, config); }); });
                                return file;
                            }, fs_1.mapExt(function () { return '.html'; }), fs_1.mapRoot(function () { return config.dest.html; }), sdh_1.save())
                                .pipe(rxline_1.handleError(function (err, file, rethrow) {
                                rethrow(new Error(chalk_1.default(templateObject_1 || (templateObject_1 = __makeTemplateObject(["{redBright # ERROR} in {underline ", "}\n", ""], ["{redBright # ERROR} in {underline ", "}\\n", ""])), file.path, (err === null || err === void 0 ? void 0 : err.message) || err)));
                            }))
                                .peek(function (file) { return console.log("" + chalk_1.default.green('#') + chalk_1.default.gray(' built:: .........') + " " + path_1.join(file.root, file.path)); })
                                .process()
                                .collect(rxline_1.sequentially, function (built) { return __awaiter(_this, void 0, void 0, function () {
                                var _i, _a, hook;
                                return __generator(this, function (_b) {
                                    switch (_b.label) {
                                        case 0:
                                            console.log("" + chalk_1.default.gray('# building ........ ' + _styles.path));
                                            return [4 /*yield*/, _styles.save()];
                                        case 1:
                                            _b.sent();
                                            console.log(chalk_1.default.green('#') + " " + chalk_1.default.gray('built:: .........') + " " + _styles.path);
                                            console.log("" + chalk_1.default.gray('# building ........ ' + _bundle.path));
                                            return [4 /*yield*/, sdh_1.save(_bundle, webpackConfig)];
                                        case 2:
                                            _b.sent();
                                            _bundle.repack = false;
                                            console.log(chalk_1.default.green('#') + " " + chalk_1.default.gray('built:: .........') + " " + _bundle.path);
                                            if (!config.afterBuild) return [3 /*break*/, 6];
                                            console.log(chalk_1.default.gray('# running after build hooks ...'));
                                            _i = 0, _a = config.afterBuild;
                                            _b.label = 3;
                                        case 3:
                                            if (!(_i < _a.length)) return [3 /*break*/, 6];
                                            hook = _a[_i];
                                            console.log(chalk_1.default.gray('# running ......... ' + hook.name + '()'));
                                            return [4 /*yield*/, hook({ config: config, built: built, source: source, partial: false })];
                                        case 4:
                                            _b.sent();
                                            console.log(chalk_1.default.green('#') + " " + chalk_1.default.gray('finished:: ......') + " " + hook.name + "()");
                                            _b.label = 5;
                                        case 5:
                                            _i++;
                                            return [3 /*break*/, 3];
                                        case 6:
                                            resolve({ bundle: _bundle, styles: _styles, toc: _toc });
                                            return [2 /*return*/];
                                    }
                                });
                            }); }, reject);
                        })];
            }
        });
    });
}
exports.build = build;
var templateObject_1;
//# sourceMappingURL=index.js.map