"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var katex_1 = require("katex");
var style_1 = require("./style");
function Formula(options, renderer, content) {
    var classes = this.theme.classes(style_1.FormulaStyle);
    var marker = renderer.create("div", null, content);
    var holder = renderer.create("div", { class: classes.formula
            + (" " + (options && options.align === 'center' ? 'center' : ''))
            + (" " + (options && options.size === 'large' ? 'big' : '')) });
    marker.childNodes.forEach(function (child, index) {
        var formula = '';
        if (child instanceof HTMLPreElement && child.querySelector('[data-content]')) {
            child.querySelectorAll('[data-content]').forEach(function (l$) {
                formula += l$.getAttribute('data-content');
            });
        }
        else
            formula = child.textContent || '';
        formula = formula.trim();
        var line$ = renderer.create("div", { "data-formula": formula, class: classes.line, _innerHTML: katex_1.renderToString(formula) });
        renderer.render(renderer.create("span", { class: "counter" }, index + 1)).on(line$);
        renderer.render(line$).on(holder);
    });
    return holder;
}
exports.Formula = Formula;
//# sourceMappingURL=component.js.map