"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var node_watch_1 = __importDefault(require("node-watch"));
var path_1 = require("path");
var rxjs_1 = require("rxjs");
var operators_1 = require("rxjs/operators");
var config_1 = require("./config");
var ASSET_EXTENSIONS = [
    '.jpg', '.jpeg', '.png', '.gif', '.svg', '.webp',
    '.woff', '.woff2', '.ttf', '.otf', '.eot',
    '.css' // --> stylesheets
];
function watchAssets(root, config, state) {
    var change$ = new rxjs_1.Subject();
    node_watch_1.default(path_1.join(root, config.dest.assets), {
        recursive: true,
        filter: function (f) { return ASSET_EXTENSIONS.some(function (extension) { return f.toLowerCase().endsWith(extension); }); }
    }, function (_, filename) { return change$.next(filename); });
    return change$.pipe(operators_1.debounceTime(10), operators_1.filter(function () { return state.value.status !== config_1.StatusBuildingResponse; }));
}
exports.watchAssets = watchAssets;
//# sourceMappingURL=watch-assets.js.map