import { funcTransport, onReady } from '@connectv/sdh/transport';
import { copyToClipboard } from '../../transport/clipboard';
import { getRenderer } from '../../transport/renderer';
import { Overlay } from '../util/overlay';
export function zoomOnFormula() {
    const renderer = getRenderer();
    onReady(() => {
        const _exec = () => {
            document.querySelectorAll('[data-formula]').forEach(div$ => {
                div$.addEventListener('click', () => {
                    var _a;
                    const clone$ = div$.cloneNode(true);
                    (_a = clone$.querySelector('.counter')) === null || _a === void 0 ? void 0 : _a.remove();
                    clone$.setAttribute('class', '');
                    copyToClipboard(clone$.getAttribute('data-formula') || '', () => {
                        renderer.render(renderer.create(Overlay, null,
                            renderer.create("div", { style: "white-space: nowrap" }, clone$))).on(document.body);
                    });
                });
            });
        };
        _exec();
        window.addEventListener('navigation', _exec);
    });
}
export const zoomOnFormula$ = /*#__PURE__*/ funcTransport(zoomOnFormula);
//# sourceMappingURL=zoom-on-formula.js.map