import { TocStyle } from './style';
export function ToC(options, renderer, content) {
    const classes = this.theme.classes(TocStyle);
    return renderer.create("div", { id: "-codedoc-toc", class: classes.toc },
        options.default === 'open' ?
            renderer.create("script", null, `
     if (window.matchMedia('(min-width: 1200px)').matches) {
       if (!localStorage.getItem('-codedoc-toc-active')) {
         localStorage.setItem('-codedoc-toc-active', "true");
       }
     }
     `)
            : '',
        renderer.create("div", { class: classes.content }, content),
        options.search ?
            renderer.create("div", { class: classes.search }, options.search) : '');
}
export * from './heading';
export * from './toggle';
export * from './search';
export * from './prevnext';
export { TocStyle } from './style';
//# sourceMappingURL=index.js.map